#!/usr/bin/perl
# $Id: sysfs-ctl.pl 349 2009-12-18 12:59:22Z bd $

use Getopt::Long;

my ($CHAN,$VIDEO,$AUDIO);
GetOptions('channel=s' => \$CHAN, 'video=s' => \$VIDEO, 'audio=s' => \$AUDIO);

my @ids = split(/\s+/, `ls -d /sys/class/pvrusb2/*/`);
if (@ids) {
    if (defined $CHAN) {
	my $hz = 1e6 * $CHAN;
	system "echo $hz > $ids[0]ctl_frequency/cur_val";
    }
    if (defined $VIDEO) {
	if ($VIDEO =~ m/^tv$/i) {
	    system "echo 60000 > $ids[0]ctl_volume/cur_val";
	    system "echo 4x3 > $ids[0]ctl_video_aspect/cur_val";
	    system "echo television > $ids[0]ctl_input/cur_val";
	} elsif ($VIDEO =~ m/^(rca|composite)$/i) {
	    system "echo 58000 > $ids[0]ctl_volume/cur_val";
	    system "echo 16x9 > $ids[0]ctl_video_aspect/cur_val";
	    system "echo composite > $ids[0]ctl_input/cur_val";
	} elsif ($VIDEO =~ m/^(svideo|s-video)$/i) {
	    system "echo 58000 > $ids[0]ctl_volume/cur_val";
	    system "echo 16x9 > $ids[0]ctl_video_aspect/cur_val";
	    system "echo s-video > $ids[0]ctl_input/cur_val";
	}
    }
}

